﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Ableitungen {
    /// <summary>
    /// Interaction logic for FInputAchse.xaml
    /// </summary>
    public partial class FInputAchse : Window {

        private string C_REG_ADR = "SOFTWARE\\WILHELM\\LAGRANGE";

        private String dbtable = "FInputAchse";

        private bool retcode = false;
        public bool Retcode {
            get { return retcode; }
        }

        public decimal xa = 0;
        public decimal xsw = 0;
        public decimal xe = 0;



        public FInputAchse(Window owner, decimal xa, decimal xsw, decimal xe) {
            InitializeComponent();

            Basis.setWindowPositionFromRegistryWidthHeight(this, C_REG_ADR + "\\position", "dialog" + dbtable);
            this.Owner = owner;  // Important, because CenterOwner           
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            this.xa = xa;
            this.xsw = xsw;
            this.xe = xe;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            txa.Text = xa.ToString("0.0000");
            txsw.Text = xsw.ToString("0.0000");
            txe.Text = xe.ToString("0.0000");
            txa.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (txa.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte einen Anfangs-Wert ein", "Hinweis");
                txa.Focus();
                return;
            }
            if (txsw.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Schrittseite ein", "Hinweis");
                txsw.Focus();
                return;
            }
            if (txe.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte einen Endwert ein", "Hinweis");
                txe.Focus();
                return;
            }

            if (!Check.tryDecimalPosNeg(txa.Text.Trim(), out xa)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen Anfangswert ein", "Hinweis");
                txa.Focus();
                return;
            }

            if (!Check.tryDecimalPosNeg(txsw.Text.Trim(), out xsw)) {
                Basis.ErrorMsg("Geben Sie bitte eine gültige Schrittweite ein", "Hinweis");
                txsw.Focus();
                return;
            }

            if (!Check.tryDecimalPosNeg(txe.Text.Trim(), out xe)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen Endwert ein", "Hinweis");
                txe.Focus();
                return;
            }

            if (xa == xe) {
                Basis.ErrorMsg("Der Anfangswert muss kleiner dem Endwert sein", "Hinweis");
                txe.Focus();
                return;
            }
            if (xsw == 0.0m) {
                Basis.ErrorMsg("Die Schrittweite muss ungleich Null sein", "Hinweis");
                txsw.Focus();
                return;
            }
            if (xa < xe && xsw < 0) {
                Basis.ErrorMsg("Die Schrittweite muss größer Null sein", "Hinweis");
                txe.Focus();
                return;
            }
            if (xa > xe && xsw > 0) {
                Basis.ErrorMsg("Die Schrittweite muss kleiner Null sein", "Hinweis");
                txe.Focus();
                return;
            }

            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Cancel)) {
                e.Handled = true;
                bnEsc_Click(sender, e);
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, C_REG_ADR + "\\position", "dialog" + dbtable);
        }

        private void tTextBox_GotFocus(Object sender, RoutedEventArgs e) {
            TextBox t = (TextBox)sender;
            t.SelectAll();
        }
    }
}
