﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

// https://www.mathepower.com/kurvendiskussion.php

namespace Ableitungen {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {
        private String dbtable = "Ableitungen1";

        private string C_REG_ADR = "SOFTWARE\\WILHELM\\ABLEITUNGEN";

        private XYGraphic graph = null;

        private decimal a4 = 0, a3 = 0, a2 = 0, a1 = 0, a0=0;
        private decimal b4=0, b3 = 0, b2 = 0, b1 = 0, b0 = 0;        // 1. ableitung
        private decimal c4 = 0, c3 = 0, c2 = 0, c1 = 0, c0 = 0;      // 2. ableitung
        private decimal d4=0, d3 = 0, d2 = 0, d1 = 0, d0 = 0;        // 3. ableitung
        private decimal xmin = 0, xmax = 0, ymin = 0, ymax=0;


        private StringBuilder sb = new StringBuilder();

        private int fontsize = 18;


        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            graph = new XYGraphic(this);
            graphicPanel.Children.Add(graph);

            LkBeispielScript4_Click(null, null);

            Basis.setWindowPositionFromRegistry(this, C_REG_ADR + "\\position", "table" + dbtable);

            setfontsize(20);
            }


        private void Window_PreviewMouseWheel(Object sender, MouseWheelEventArgs e) {
            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Control)) {
                //Title = e.Delta.ToString();
                e.Handled = true;
                if (e.Delta > 0) {
                    fontsize += 2;
                    if (fontsize > 34) fontsize = 34;
                }
                else {
                    fontsize -= 2;
                    if (fontsize < 8) fontsize = 8;
                }
                clearFontMenues(null);
                switch (fontsize) {
                    case 8:
                        mnFont8pg.IsChecked = false;
                        break;
                    case 10:
                        mnFont10pg.IsChecked = false;
                        break;
                    case 12:
                        mnFont12pg.IsChecked = false;
                        break;
                    case 14:
                        mnFont14pg.IsChecked = false;
                        break;
                    case 16:
                        mnFont16pg.IsChecked = false;
                        break;
                    case 18:
                        mnFont18pg.IsChecked = false;
                        break;
                    case 20:
                        mnFont20pg.IsChecked = false;
                        break;
                    case 22:
                        mnFont22pg.IsChecked = false;
                        break;
                    case 24:
                        mnFont24pg.IsChecked = false;
                        break;
                    case 26:
                        mnFont26pg.IsChecked = false;
                        break;
                    case 28:
                        mnFont28pg.IsChecked = false;
                        break;
                    case 30:
                        mnFont30pg.IsChecked = false;
                        break;
                    case 32:
                        mnFont32pg.IsChecked = false;
                        break;
                    case 34:
                        mnFont34pg.IsChecked = false;
                        break;
                }

                setfontsize(Convert.ToInt32(fontsize));
            }
        }
        private void mnFont_Click(Object sender, RoutedEventArgs e) {
            MenuItem mn = (MenuItem)sender;
            clearFontMenues(sender);
            setfontsize(Convert.ToInt32(mn.Tag));
        }

        private void mnAbleitung1_Click(Object sender, RoutedEventArgs e) {
            mnAbleitung1.IsChecked = !mnAbleitung1.IsChecked;
            bnCalc_Click(null, null);
        }
        private void mnAbleitung2_Click(Object sender, RoutedEventArgs e) {
            mnAbleitung2.IsChecked = !mnAbleitung2.IsChecked;
            bnCalc_Click(null, null);
        }
        private void mnAbleitung3_Click(Object sender, RoutedEventArgs e) {
            mnAbleitung3.IsChecked = !mnAbleitung3.IsChecked;
            bnCalc_Click(null, null);
        }

        private void clearFontMenues(object sender) {
            mnFont8pg.IsChecked = false;
            mnFont10pg.IsChecked = false;
            mnFont12pg.IsChecked = false;
            mnFont14pg.IsChecked = false;
            mnFont16pg.IsChecked = false;
            mnFont18pg.IsChecked = false;
            mnFont20pg.IsChecked = false;
            mnFont24pg.IsChecked = false;
            mnFont28pg.IsChecked = false;
            mnFont30pg.IsChecked = false;
            mnFont32pg.IsChecked = false;
            mnFont34pg.IsChecked = false;
            if (sender != null) {
                MenuItem mnItem = (MenuItem)sender;
                mnItem.IsChecked = true;
            }
        }
        private void setfontsize(int size) {
            this.fontsize = size;
            mainMenu.FontSize = size;
            mnClose.FontSize = size;
            mainSamples.FontSize = size;
            mnSamples1.FontSize = size;
            mnSamples2.FontSize = size;
            mnSamples3.FontSize = size;
            mnSamples4.FontSize = size;
            mnSamples5.FontSize = size;
            mnSamples6.FontSize = size;
            mainView.FontSize = size;
            mainFont.FontSize = size;
            mnFont8pg.FontSize = size;
            mnFont10pg.FontSize = size;
            mnFont12pg.FontSize = size;
            mnFont14pg.FontSize = size;
            mnFont16pg.FontSize = size;
            mnFont18pg.FontSize = size;
            mnFont20pg.FontSize = size;
            mnFont22pg.FontSize = size;
            mnFont24pg.FontSize = size;
            mnFont26pg.FontSize = size;
            mnFont28pg.FontSize = size;
            mnFont30pg.FontSize = size;
            mnFont32pg.FontSize = size;
            mnFont34pg.FontSize = size;

            ta4.FontSize = size;
            ta3.FontSize = size;
            ta2.FontSize = size;
            ta1.FontSize = size;
            ta0.FontSize = size;
            labela4.FontSize = size;
            labela3.FontSize = size;
            labela2.FontSize = size;
            labela1.FontSize = size;
            labelxmin.FontSize = size;
            labelxmax.FontSize = size;
            labelymin.FontSize = size;
            labelymax.FontSize = size;
            txmin.FontSize = size;
            txmax.FontSize = size;
            tymin.FontSize = size;
            tymax.FontSize = size;
            tabcontrol.FontSize = size;
            bnCalc.FontSize = size;
        }

        private void LkBeispielScript1_Click(Object sender, RoutedEventArgs e) {
            Title = "x^4  -5·x³ - 5";
            txmin.Text = "-3.0";
            txmax.Text = "+6.0";
            tymin.Text = "-80.0";
            tymax.Text = "+30.0";

            ta4.Text = "1";
            ta3.Text = "-5";
            ta2.Text = "0";
            ta1.Text = "0";
            ta0.Text = "-5";
            bnCalc_Click(null, null);
        }

        private void LkBeispielScript2_Click(Object sender, RoutedEventArgs e) {
            Title = "-0.25·x^4  + 3·x³ + x -2";
            txmin.Text = "-5";
            txmax.Text = "+5";
            tymin.Text = "-20";
            tymax.Text = "+10";

            ta4.Text = "-0.25";
            ta3.Text = "0";
            ta2.Text = "3";
            ta1.Text = "1";
            ta0.Text = "-2";
            bnCalc_Click(null, null);
        }


        private void LkBeispielScript3_Click(Object sender, RoutedEventArgs e) {
            Title = "0.5·x^4  - x³ - 0.5·x²";
            txmin.Text = "-2.0";
            txmax.Text = "+3.0";
            tymin.Text = "-1.0";
            tymax.Text = "+2.0";

            ta4.Text = "0.5";
            ta3.Text = "-1";
            ta2.Text = "0.5";
            ta1.Text = "0";
            ta0.Text = "0";
            bnCalc_Click(null, null);
        }

        private void LkBeispielScript4_Click(Object sender, RoutedEventArgs e) {
            Title = "x³ - 4·x² - 3·x + 5";
            txmin.Text = "-4.0";
            txmax.Text = "+6.0";
            tymin.Text = "-20.0";
            tymax.Text = "+20.0";

            ta4.Text = "0";
            ta3.Text = "1";
            ta2.Text = "-4";
            ta1.Text = "-3";
            ta0.Text = "+5";
            bnCalc_Click(null, null);

        }

        // x² -4
        private void LkBeispielScript5_Click(Object sender, RoutedEventArgs e) {
            Title = "x² - 4";
            txmin.Text = "-10.0";
            txmax.Text = "+10.0";
            tymin.Text = "-5.0";
            tymax.Text = "+50.0";

            ta4.Text = "0";
            ta3.Text = "0";
            ta2.Text = "1";
            ta1.Text = "0";
            ta0.Text = "-4";
            bnCalc_Click(null, null);

        }

        // x² + 4
        private void LkBeispielScript6_Click(Object sender, RoutedEventArgs e) {
            Title = "x² + 1";
            txmin.Text = "-10.0";
            txmax.Text = "+10.0";
            tymin.Text = "-10.0";
            tymax.Text = "+50.0";

            ta4.Text = "0";
            ta3.Text = "0";
            ta2.Text = "1";
            ta1.Text = "0";
            ta0.Text = "1";
            bnCalc_Click(null, null);

        }

        // 2·x² +6·x  + 4
        private void LkBeispielScript7_Click(Object sender, RoutedEventArgs e) {
            Title = "2·x² +6·x  + 4";
            txmin.Text = "-10.0";
            txmax.Text = "+10.0";
            tymin.Text = "-5.0";
            tymax.Text = "+50.0";

            ta4.Text = "0";
            ta3.Text = "0";
            ta2.Text = "2";
            ta1.Text = "6";
            ta0.Text = "4";
            bnCalc_Click(null, null);

        }

        // 2·x² +6·x  + 4
        private void LkBeispielScript8_Click(Object sender, RoutedEventArgs e) {
            Title = "x² + 2·x  - 4";
            txmin.Text = "-8.0";
            txmax.Text = "+6.0";
            tymin.Text = "-5.0";
            tymax.Text = "+30.0";

            ta4.Text = "0";
            ta3.Text = "0";
            ta2.Text = "1";
            ta1.Text = "0";
            ta0.Text = "-4";
            bnCalc_Click(null, null);

        }

        // 2·x³
        private void LkBeispielScript9_Click(Object sender, RoutedEventArgs e) {
            Title = "0.5·x³";
            txmin.Text = "-6.0";
            txmax.Text = "+6.0";
            tymin.Text = "-30.0";
            tymax.Text = "+30.0";

            ta4.Text = "0";
            ta3.Text = "0.5";
            ta2.Text = "0";
            ta1.Text = "0";
            ta0.Text = "0";
            bnCalc_Click(null, null);

        }


        // 2·x³
        private void LkBeispielScript10_Click(Object sender, RoutedEventArgs e) {
            Title = "0.5·x³ + 4";
            txmin.Text = "-6.0";
            txmax.Text = "+6.0";
            tymin.Text = "-30.0";
            tymax.Text = "+30.0";

            ta4.Text = "0";
            ta3.Text = "0.5";
            ta2.Text = "0";
            ta1.Text = "0";
            ta0.Text = "4";
            bnCalc_Click(null, null);

        }

        private void LkBeispielScript11_Click(Object sender, RoutedEventArgs e) {
            Title = "x³ - 3·x² - 4·x + 12";
            txmin.Text = "-3.0";
            txmax.Text = "+5.0";
            tymin.Text = "-20.0";
            tymax.Text = "+20.0";

            ta4.Text = "0";
            ta3.Text = "1";
            ta2.Text = "-3";
            ta1.Text = "-4";
            ta0.Text = "12";
            bnCalc_Click(null, null);
        }



        private void tTextBox_GotFocus(Object sender, RoutedEventArgs e) {
            TextBox t = (TextBox)sender;
            t.SelectAll();
        }

        private void bnCalc_Click(Object sender, RoutedEventArgs e) {
            sb.Clear();
            
            if (!Check.tryDecimalPosNeg(txmin.Text.Trim(), out xmin)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen Anfangswert ein", "Hinweis");
                txmin.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(txmax.Text.Trim(), out xmax)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen Endwert ein", "Hinweis");
                txmax.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(tymin.Text.Trim(), out ymin)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen Anfangswert ein", "Hinweis");
                tymin.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(tymax.Text.Trim(), out ymax)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen Endwert ein", "Hinweis");
                tymax.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(ta4.Text.Trim(), out a4)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen a4 ein", "Hinweis");
                ta4.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(ta3.Text.Trim(), out a3)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen a3 ein", "Hinweis");
                ta3.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(ta2.Text.Trim(), out a2)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen a2 ein", "Hinweis");
                ta2.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(ta1.Text.Trim(), out a1)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen a1 ein", "Hinweis");
                ta1.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(ta0.Text.Trim(), out a0)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen a0 ein", "Hinweis");
                ta0.Focus();
                return;
            }

            calcDatas();
            editor.Text = sb.ToString();


            graph.deleteCoords();
            decimal xsw = 1.0m;
            decimal ysw = 1.0m;
            round(ref xmin, ref xsw, ref xmax, xmax);
            round(ref ymin, ref ysw, ref ymax, ymax);
            decimal x = xmin;


            graph.setGraphic(Title, "X-Achse", "Y-Achse", xmin, xsw, xmax, ymin, ysw, ymax);
            graph.setCoeff1(a4, a3, a2, a1, a0);

            if (mnAbleitung1.IsChecked==true) {
                graph.setCoeff2(b4, b3, b2, b1, b0);
            }
            else {
                graph.deleteCoeff2();
            }

            if (mnAbleitung2.IsChecked == true) {
                graph.setCoeff3(c4, c3, c2, c1, c0);
            }
            else {
                graph.deleteCoeff3();
            }

            if (mnAbleitung3.IsChecked == true) {
                graph.setCoeff4(d4, d3, d2, d1, d0);
            }
            else {
                graph.deleteCoeff4();
            }

            graph.setAchseX(Brushes.BlueViolet, 3);
            graph.setAchseY(Brushes.BlueViolet, 3);

            graph.InvalidateVisual();

            sb.Clear();
            sb.AppendLine("WERTETABELLE\r\n");
            sb.Append(" f(x)  =  ");
            printFunction(a4, a3, a2, a1, a0);
            sb.AppendLine();
            sb.AppendLine("x\ty");
            for (decimal xLoop =-10; xLoop <=+10; xLoop+=0.5m) {
                decimal y = fx(a4, a3, a2, a1, a0, xLoop);
                sb.Append(xLoop.ToString());
                sb.Append("\t");
                sb.AppendLine(y.ToString("0.000"));
            }
            valuetableEditor.Text = sb.ToString();

        }  // bnCalc_Click

        private void printFunction(decimal a4, decimal a3, decimal a2, decimal a1, decimal a0) {
            if (a4 != 0.0m) {
                if (a4 != 1.0m) {
                    sb.Append(a4);
                    sb.Append(" · x^4");
                }
                else {
                    sb.Append(" x^4");
                }
                
            }

            if (a3 != 0.0m) {
                if (a3 > 0) {
                    sb.Append(" + ");
                    if (a3 != 1.0m) {
                        sb.Append(a3);
                        sb.Append("·x³");
                    }
                    else {
                        sb.Append("x³");
                    }
                    
                }                    
                else { 
                    sb.Append(" - ");
                    if (a3 != 1.0m) {
                        sb.Append(-a3);
                        sb.Append("·x³");
                    }
                    else {
                        sb.Append("x³");
                    }
                }                
            }

            if (a2 != 0.0m) {
                if (a2 > 0) {
                    sb.Append(" + ");
                    if (a2 != 1.0m) {
                        sb.Append(a2);
                        sb.Append("·x²");
                    }
                    else {
                        sb.Append("x²");
                    }

                }
                else {
                    sb.Append(" - ");
                    if (a2 != 1.0m) {
                        sb.Append(-a2);
                        sb.Append("·x²");
                    }
                    else {
                        sb.Append("x²");
                    }
                }
            }


            if (a1 != 0.0m) {
                if (a1 > 0) {
                    sb.Append(" + ");
                    if (a1 != 1.0m) {
                        sb.Append(a1);
                        sb.Append("·x");
                    }
                    else {
                        sb.Append("x");
                    }

                }
                else {
                    sb.Append(" - ");
                    if (a1 != 1.0m) {
                        sb.Append(-a1);
                        sb.Append("·x");
                    }
                    else {
                        sb.Append("x");
                    }
                }
            }



            if (a0 != 0.0m) {
                if (a0 > 0) {
                    sb.Append(" + ");
                    sb.AppendLine(a0.ToString());
                }
                else {
                    sb.Append(" - ");
                    sb.AppendLine((-a0).ToString());
                }
            }
        }  // printFunction


        private void calcDatas() {
            sb.Append(" f(x)  =  ");
            printFunction(a4, a3, a2, a1, a0);
            sb.AppendLine();

            // Nullstellen bestimmen
            if (a4==0.0m && a3==0.0m) {
                nullstellenPQ(a2, a1, a0);
            }
            else {
                nullstellen(a4, a3, a2, a1, a0);
            }

            sb.AppendLine();
            sb.AppendLine("Schnittstelle mit der Y-Achse");
            decimal y = fx(a4, a3, a2, a1, a0, 0);
            sb.AppendLine("Schnittpunkt: "+y.ToString("0.0000"));
            sb.AppendLine();

            // Y-Achse Symmetrie
            sb.AppendLine();
            sb.AppendLine("Symmetrie");
            decimal y1 = fx(a4, a3, a2, a1, a0, 1);
            decimal y2 = fx(a4, a3, a2, a1, a0, -1);
            if (y1==y2) {
                sb.AppendLine("  Symmetrie der Y-Achse");
            }
            else {
                sb.AppendLine("  Keine Symmetrie der Y-Achse");
            }

            // Y-Achse Symmetrie
            y1 = fx(a4, a3, a2, a1, a0, -1);
            y2 = -fx(a4, a3, a2, a1, a0, 1);
            if (y1 == y2) {
                sb.AppendLine("  Punktsymmetrie des Nullpunkts");
            }
            else {
                sb.AppendLine("Keine Punktsymmetrie");
            }
            sb.AppendLine();

            sb.AppendLine("Verhalten im Unendlichen");
            bool even = false;
            bool constant = false;
            if (a4 != 0.0m) {
                even = false;
            }
            else {
                if (a3 != 0.0m) {
                    even = false;
                }
                else {
                    if (a2 != 0.0m) {
                        even = true;
                    }
                    else {
                        if (a1 != 0.0m) {
                            even = false;
                        }
                        else {
                            if (a0 != 0.0m) {
                                even = false;
                            }
                            else {
                                constant = true;
                            }
                        }
                    }
                }
            }
            if (constant) {
                sb.AppendLine("  lim x->-∞:  " + a0);
                sb.AppendLine("  lim x->+∞:  " + a0);
            }
            else {
                if (even) {
                    sb.AppendLine("  lim x->-∞:  +∞");
                    sb.AppendLine("  lim x->+∞:  +∞");
                }
                else {
                    sb.AppendLine("  lim x->-∞:  -∞");
                    sb.AppendLine("  lim x->+∞:  +∞");
                }

            }
            sb.AppendLine();

            // 1. Ableitung
            b4 = 0;
            b3 = 4 * a4;
            b2 = 3 * a3;
            b1 = 2 * a2;
            b0 = a1;

            c4 = 0;
            c3 = 0;
            c2 = 3 * b3;
            c1 = 2 * b2;
            c0 = b1;

            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("1. Ableitung");
            sb.Append(" f'(x)  =  ");
            printFunction(b4, b3, b2, b1, b0);
            sb.AppendLine();

            List<decimal> listeExtrema;
            if (b4 == 0.0m && b3 == 0.0m) {
                listeExtrema = nullstellenPQ(b2, b1, b0);
            }
            else {
                listeExtrema = nullstellen(b4, b3, b2, b1, b0);
            }
            // lokale Extrema prüfen
            foreach(decimal x0 in listeExtrema) {
                decimal y0 = fx(c4, c3, c2, c1, c0, x0);
                if (y0<0.0m) {
                    sb.Append("Die Nullstelle ");
                    sb.Append(x0.ToString("0.000000000"));
                    sb.AppendLine("  ist lokales Maximum");
                }
                else if (y0 > 0.0m) {
                    sb.Append("Die Nullstelle ");
                    sb.Append(x0.ToString("0.000000000"));
                    sb.AppendLine("  ist lokales Minimum");
                }
                else {
                    sb.Append("Die Nullstelle ");
                    sb.Append(x0.ToString("0.000000000"));
                    sb.AppendLine("  ist kein Minimum oder Maximum");
                }
            }


            // 2. Ableitung
            c4 = 0;
            c3 = 0;
            c2 = 3 * b3;
            c1 = 2 * b2;
            c0 = b1;
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("2. Ableitung");
            sb.Append(" f''(x)  =  ");
            printFunction(c4, c3, c2, c1, c0);
            sb.AppendLine();


            List<decimal> wendepunkteListe;

            if (c4 == 0.0m && c3 == 0.0m) {
                wendepunkteListe = nullstellenPQ(c2, c1, c0);
            }
            else {
                wendepunkteListe = nullstellen(c4, c3, c2, c1, c0);
            }
            wendepunkteListe.Sort();

            d4 = 0;
            d3 = 0;
            d2 = 0;
            d1 = 2 * c2;
            d0 = c1;

            // Wendepunkte prüfen   f'''(x) <> 0
            foreach (decimal x0 in wendepunkteListe) {
                decimal y0 = fx(d4, d3, d2, d1, d0, x0);
                if (y0==0) {
                    sb.Append("Die Nullstelle ");
                    sb.Append(x0.ToString("0.000000000"));
                    sb.AppendLine("  ist KEIN Wendepunkt");
                }
                else {
                    sb.Append("Die Nullstelle ");
                    sb.Append(x0.ToString("0.000000000"));
                    sb.AppendLine("  ist ein Wendepunkt");
                }
            }

            // f((1−m)·x1 + m·x2) >= (1−m)·f(x1) + m·f(x2)   KOnvex
            // Ist eine Funktion f(x) streng konvex, so sagt man auch, dass f(x) eine Linkskrümmung hat
            // f((1−m)·x1 + m·x2) >= (1−m)·f(x1) + m·f(x2)   konkav
            //            Eine Funktion f(x) sei auf einem Intervall[a; b] stetig und auf(a; b) zweimal stetig dierenzierbar.
            //          Dann gelten folgende Aussagen:
            //1.Gilt f(x) >= 0 für alle x € (a; b), dann ist f(x) auf(a; b) konvex.
            //2.Gilt f(x) > 0 für alle x € (a; b), dann ist f(x) auf(a; b) streng konvex.
            //3.Gilt f(x) <= 0 für alle x € (a; b), dann ist f(x) auf(a; b) konkav.
            //4.Gilt f(x) < 0 für alle x € (a; b), dann ist f(x) auf(a; b) streng konkav.
            decimal mainStep = 4;
            decimal step = 2;
            sb.AppendLine();
            sb.AppendLine("Liste der Konkav- Konvexbereiche");
            if (wendepunkteListe.Count == 0) {
                sb.Append("  Bereich: " + "-∞");
                sb.AppendLine(" ->  " + "+∞");
                if (listeExtrema.Count==1) {
                    decimal xKonkav = listeExtrema[0];
                    decimal yKonkav = fx(c4, c3, c2, c1, c0, xKonkav);
                    if (yKonkav<0) {
                        sb.Append("  Bereich ist konkav");
                    }
                    else {
                        if (yKonkav > 0) {
                            sb.Append("  Bereich ist konvex");
                        }
                        else {
                            sb.Append("  Konvex bzw. konkav ist nicht entscheidbar.");
                        }
                    }
                }
            }
            else {
                if (wendepunkteListe.Count == 1) {
                    // entspricht x³
                    sb.Append("  Bereich: " + "-∞");
                    sb.AppendLine("  ->  " + wendepunkteListe[0].ToString("0.0000"));
                    decimal x1 = wendepunkteListe[0];
                    y1 = fx(a4, a3, a2, a1, a0, x1);
                    decimal x2 = wendepunkteListe[0] - mainStep;
                    y2 = fx(a4, a3, a2, a1, a0, x2);
                    decimal m = (y2 - y1) / (x2 - x1);
                    // zwischenpunkt
                    decimal b = y1 - m * x1;
                    x1 = wendepunkteListe[0] - step;
                    y1 = fx(a4, a3, a2, a1, a0, x1);
                    decimal yGerade = m * x1 + b;
                    if (y1>yGerade)
                        sb.Append("  Bereich ist konkav");
                    else
                        sb.Append("  Bereich ist konvex");
                    sb.AppendLine();
                    sb.AppendLine();


                    sb.Append("  Bereich: " + wendepunkteListe[0].ToString("0.0000"));
                    sb.AppendLine(" ->  " + "+∞");
                    x1 = wendepunkteListe[0];
                    y1 = fx(a4, a3, a2, a1, a0, x1);
                    x2 = wendepunkteListe[0] + mainStep;
                    y2 = fx(a4, a3, a2, a1, a0, x2);
                    m = (y2 - y1) / (x2 - x1);
                    // zwischenpunkt
                    b = y1 - m * x1;
                    x1 = wendepunkteListe[0] + step;
                    y1 = fx(a4, a3, a2, a1, a0, x1);
                    yGerade = m * x1 + b;
                    if (y1 < yGerade)
                        sb.Append("  Bereich ist konvex");
                    else
                        sb.Append("  Bereich ist konkav");
                    sb.AppendLine();
                    sb.AppendLine();
                }  
                else {
                    for (int i = 0; i < wendepunkteListe.Count; i++) {
                        if (i == 0) {
                            sb.Append("  Bereich: " + "-∞");
                            sb.AppendLine("  ->  " + wendepunkteListe[i].ToString("0.0000"));
                            sb.Append("  Bereich: " + wendepunkteListe[i].ToString("0.0000"));
                            sb.AppendLine(" ->  " + wendepunkteListe[i + 1].ToString("0.0000"));
                        }
                        else {
                            if (i < (wendepunkteListe.Count - 1)) {
                                sb.Append(" Bereich: " + wendepunkteListe[i].ToString("0.0000"));
                                sb.AppendLine(" ->  " + wendepunkteListe[i + 1].ToString("0.0000"));
                            }
                            else {
                                sb.Append("  Bereich: " + wendepunkteListe[i].ToString("0.0000"));
                                sb.AppendLine(" ->  " + "-∞");
                            }

                        }
                    }
                }
            }
            sb.AppendLine();
            // 3. Ableitung
            d4 = 0;
            d3 = 0;
            d2 = 3 * c3;
            d1 = 2 * c2;
            d0 = c1;
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("3. Ableitung");
            sb.Append(" f'''(x)  =  ");
            printFunction(d4, d3, d2, d1, d0);
            sb.AppendLine();

        }

        private decimal fx(decimal a4, decimal a3, decimal a2, decimal a1, decimal a0, decimal x) {
            return (((a4 * x + a3) * x + a2) * x + a1) * x + a0;
        }

        private List<decimal> nullstellenPQ(decimal a2, decimal a1, decimal a0) {
            List<decimal> liste = new List<decimal>();
            decimal sqrt = a1 * a1 - 4 * a2 * a0;
            if (sqrt<0.0m ||  (a2==0 && a1==0) ) {
                sb.AppendLine("     es gibt KEINE Nullstelle:");
            }
            else {
                double dSqrt = (double)sqrt;
                decimal wurzel = (decimal) Math.Sqrt(dSqrt);
                if (a2==0) {
                    // a1*x + a0    ==>   x = -a0/a1
                    decimal x1 = -a0/a1;
                    decimal y1 = fx(a4, a3, a2, a1, a0, x1);
                    sb.Append("     EINE Nullstelle:");
                    sb.Append(" P: (");
                    sb.Append(x1.ToString("0.000000000"));
                    sb.Append(y1.ToString("0.000"));
                    sb.Append(" )  ");
                    sb.AppendLine();
                    liste.Add(x1);
                }
                else {
                    decimal x1 = (-a1 + wurzel) / (2 * a2);
                    decimal x2 = (-a1 - wurzel) / (2 * a2);
                    decimal y1 = fx(a4, a3, a2, a1, a0, x1);
                    decimal y2 = fx(a4, a3, a2, a1, a0, x2);
                    if (wurzel == 0.0m) {
                        sb.Append("     EINE Nullstelle:");
                        sb.Append(" P: (");
                        sb.Append(x1.ToString("0.000000000"));
                        sb.Append(y1.ToString("0.000"));
                        sb.Append(" )  ");
                        sb.AppendLine();
                        liste.Add(x1);
                    }
                    else {
                        sb.Append("1. Nullstelle:");
                        sb.Append(" P1: (");
                        sb.Append(x1.ToString("0.000000000"));
                        sb.Append(" / ");
                        sb.Append(y1.ToString("0.000"));
                        sb.AppendLine(" )  ");
                        liste.Add(x1);

                        sb.Append("2. Nullstelle:");
                        sb.Append(" P2: (");
                        sb.Append(x2.ToString("0.000000000"));
                        sb.Append(" / ");
                        sb.Append(y2.ToString("0.000"));
                        sb.AppendLine(" )  ");
                        sb.AppendLine();
                        liste.Add(x2);
                    }
                }

            }
            return liste;
        }

        class Nullstelle : IComparable {
            public decimal x = 0.0m;
            public decimal y = 0.0m;

            public decimal x1 = 0.0m;
            public decimal y1 = 0.0m;
            public decimal x2 = 0.0m;
            public decimal y2= 0.0m;
            public bool intervall = false;

            public Nullstelle(decimal x, decimal y) {
                this.x = x;
                this.y = y;
            }
            public Nullstelle(decimal x, decimal y, decimal x1, decimal y1, decimal x2, decimal y2) {
                this.x = x;
                this.y = y;
                this.x1 = x1;
                this.y1 = y1;
                this.x2 = x2;
                this.y2 = y2;
                intervall = true;
            }

            public int CompareTo(object obj) {
                Nullstelle nullstelle = (Nullstelle)obj;
                int erg = x.CompareTo(nullstelle.x);
                if (erg == 0) {
                    erg = y.CompareTo(nullstelle.y);
                }
                return erg;
            }
        }

        private bool checkNullstelle(List<Nullstelle> liste, decimal x) {
            foreach (Nullstelle nullstelle in liste) {
                if ( Math.Abs(nullstelle.x-x)<1.0E-4m) {
                    return false; 
                }
            }
            return true;
        }

        private List<decimal> nullstellen(decimal a4, decimal a3, decimal a2, decimal a1, decimal a0) {
            List<decimal> ergListe = new List<decimal>();
            List<Nullstelle> liste = new List<Nullstelle>();
            decimal xa, xe;
            if (xmin < -20)
                xa = xmin;
            else
                xa = -20;
            if (xmax > +20)
                xe = xmax;
            else
                xe = +20;

            for (decimal x0=-10; x0<20.0m; x0+=1.0m) {
                decimal y0 = fx(a4, a3, a2, a1, a0, x0);
                if (y0 == 0) {
                    liste.Add( new Nullstelle(x0,y0) );
                }
            }

            decimal x1 = xa;
            decimal xsw = 0.01m;
            while (x1<=xe) {
                decimal x2 = x1 + xsw;
                decimal y1 = fx(a4, a3, a2, a1, a0, x1);
                decimal y2 = fx(a4, a3, a2, a1, a0, x2);
                if (y1 == 0) {
                    if (checkNullstelle(liste, x1)) {
                        liste.Add(new Nullstelle(x1, y1));
                    }
                }
                else if ((y1 > 0 && y2 < 0) || (y1 < 0 && y2 > 0)) {
                    decimal x = calcNullstelleIntervallHalbierungsVerfahren(a4, a3, a2, a1, a0, x1, x2);
                    decimal y = fx(a4, a3, a2, a1, a0, x);
                    if (checkNullstelle(liste, x)) {
                        liste.Add(new Nullstelle(x, y, x1, y1, x2, y2));
                    }

                    
                } 
                
                x1 += xsw;
            } // while 
            liste.Sort();
            foreach(Nullstelle nullstelle in liste) {
                ergListe.Add(nullstelle.x);
                if (nullstelle.intervall) {
                    sb.Append("Nullstelle:");
                    sb.Append(" P1: (");
                    sb.Append(nullstelle.x1.ToString("0.000000000"));
                    sb.Append(" / ");
                    sb.Append(nullstelle.y1.ToString("0.000"));
                    sb.Append(" )  ");
                    sb.Append(" P2: (");
                    sb.Append(nullstelle.x2.ToString("0.000000000"));
                    sb.Append(" / ");
                    sb.Append(nullstelle.y2.ToString("0.000"));
                    sb.AppendLine(" )  ");
                    sb.Append("     Nullstelle:");
                    sb.Append(" P: (");
                    sb.Append(nullstelle.x.ToString("0.000000000"));
                    sb.Append(" / ");
                    sb.Append(nullstelle.y.ToString("0.0000"));
                    sb.AppendLine(" )  ");
                    sb.AppendLine();
                }
                else {
                    sb.Append("     Nullstelle:");
                    sb.Append(" P: (");
                    sb.Append(nullstelle.x.ToString("0.000000000"));
                    sb.Append(" / ");
                    sb.Append(nullstelle.y.ToString("0.0000"));
                    sb.AppendLine(" )  ");
                    sb.AppendLine();
                }
            }
            return ergListe;
        }

        // Achtung:  zwei Varianten   y1<y2    oder y1>y2
        private decimal calcNullstelleIntervallHalbierungsVerfahren(decimal a4, decimal a3, decimal a2, decimal a1, decimal a0, decimal x1, decimal x2) {
            decimal eps = 1.0E-6m;
            decimal x = 0, y=0;
            decimal y1, y2;
            y1 = fx(a4, a3, a2, a1, a0, x1);
            y2 = fx(a4, a3, a2, a1, a0, x2);
            if (y1<0) {
                int n = 0;
                while (Math.Abs(y1-y2)>eps || n>1000) {
                    x = (x1 + x2) * 0.5m;
                    y = fx(a4, a3, a2, a1, a0, x);
                    if (y<0) {
                        x1 = x;
                        y1 = y;
                    }
                    else {
                        x2 = x;
                        y2 = y;
                    }
                    n++;
                }
            }
            else {
                // y2<0 !
                int n = 0;
                while (Math.Abs(y1 - y2) > eps || n > 1000) {
                    x = (x1 + x2) * 0.5m;
                    y = fx(a4, a3, a2, a1, a0, x);
                    if (y < 0) {
                        x2 = x;
                        y2 = y;
                    }
                    else {
                        x1 = x;
                        y1 = y;
                    }
                    n++;
                }
            }
            return x;
        }

        private void round(ref decimal xa, ref decimal xsw, ref decimal xe, decimal xeOri) {
            decimal[] steps = { 0.5m, 1, 2, 5, 10 };

            foreach(decimal step in steps) {
                decimal n = (xe - xa) / step;
                if (n<13) {
                    xsw = step;
                    return;
                }
            }
            xsw = 10.0m;
        }
        private void mnClose_Click(Object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, C_REG_ADR + "\\position", "table" + dbtable);
        }

    }
}
