﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Collections;

namespace CalcCluster
{
    public class SearchThread
    {
        public enum SearchModi { AllFiles, Pictures, Media };

        private String sPath = "";
        public long summe;
        public long anzFiles;
        public long anzFiles_old = 0;
        Cluster[] clusters;
        IprintResult parent;
        SearchModi modi = SearchModi.AllFiles;
        ArrayList filelist = new ArrayList();

        public SearchThread(String sPath, Cluster[] clusters, SearchModi modi, IprintResult parent)
        {
            this.sPath = sPath;
            this.clusters = clusters;
            this.parent = parent;
            this.modi = modi;
            filelist.Clear();
            switch (modi)
            {
                case SearchModi.Pictures:
                                        filelist.Add(".bmp");
                                        filelist.Add(".cpt");
                                        filelist.Add(".cr2");
                                        filelist.Add(".crw");
                                        filelist.Add(".dcm");
                                        filelist.Add(".djvm");
                                        filelist.Add(".flv");
                                        filelist.Add(".gho");
                                        filelist.Add(".gif");
                                        filelist.Add(".ico");
                                        filelist.Add(".jpeg");
                                        filelist.Add(".jpg");
                                        filelist.Add(".mix");
                                        filelist.Add(".pcx");
                                        filelist.Add(".png");
                                        filelist.Add(".raw");
                                        filelist.Add(".tga");
                                        filelist.Add(".tif");
                                        filelist.Add(".tiff");
                                        filelist.Add(".wmv");
                                            break;
                case SearchModi.Media: 
                                       filelist.Add(".aif");
                                       filelist.Add(".aifc");
                                       filelist.Add(".aiff");
                                       filelist.Add(".asf");
                                       filelist.Add(".asx");
                                       filelist.Add(".au");
                                       filelist.Add(".avi");
                                       filelist.Add(".cda");
                                       filelist.Add(".dvr-ms");
                                       filelist.Add(".flac");
                                       filelist.Add(".ivf");
                                       filelist.Add(".m1v");
                                       filelist.Add(".m2u");
                                       filelist.Add(".mid");
                                       filelist.Add(".midi");
                                       filelist.Add(".mov");
                                       filelist.Add(".mp2");
                                        filelist.Add(".mp3");
                                       filelist.Add(".mp4");
                                       filelist.Add(".mpa");
                                       filelist.Add(".mpe");
                                       filelist.Add(".mpeg");
                                       filelist.Add(".mpg");
                                       filelist.Add(".mpv2");
                                       filelist.Add(".qt");
                                       filelist.Add(".ra");
                                       filelist.Add(".ram");
                                       filelist.Add(".rm");
                                       filelist.Add(".rmi");
                                       filelist.Add(".snd");
                                       filelist.Add(".wav");
                                       filelist.Add(".wax");
                                       filelist.Add(".wm");
                                       filelist.Add(".wma");
                                       filelist.Add(".wmd");
                                       filelist.Add(".wms");
                                       filelist.Add(".wmv");
                                       filelist.Add(".wmz");
                                       filelist.Add(".wpl");
                                       filelist.Add(".wvx");
                                            break;
            }
        }

        public void run()
        {
            summe = 0;
            anzFiles = 0;
            anzFiles_old = 0;
            CalcCluster(sPath);
            parent.printResult();
            parent.AddText("\r\n\r\nDateimasken:\r\n");
            foreach (String ext in filelist)
            {
                parent.AddText(ext + "\r\n");
            }
        }

       

        private void CalcCluster(String path)
        {
            Boolean bOk;
            try
            {

                string[] subdir = Directory.GetDirectories(path);
                string[] files = Directory.GetFiles(path);
                //aktDir.Text = path;
                //aktDir.Invalidate();
                    parent.printStatus(path);
                if (anzFiles != anzFiles_old)
                {
                    parent.SetText("Anzahl der Dateien: " + anzFiles + "\r\n" + "Summe: " + Basis.best_KB(summe));
                }
                anzFiles_old = anzFiles;
                foreach (String file in files)
                {
                    bOk=true;
                    if (filelist.Count > 0)
                    {
                        bOk = false;
                        foreach (String ext in filelist)
                        {
                            if (file.ToLower().EndsWith(ext))
                            {
                                bOk = true;
                                break;
                            }
                        }
                    }
                    if (bOk)  {
                        try {
                            long len = new FileInfo(file).Length;
                            summe += len;
                            anzFiles++;
                            foreach (Cluster c in clusters) {
                                c.addFile(len);
                            }
                        }
                        catch (Exception e) {
                            Basis.Error("Fehlerhafter Zugriff auf die Datei\n"+
                                file+"\nFehler: "+e.ToString(),
                                "Fehler");
                        }
                    }
                }
                foreach (String dir in subdir)
                {
                    if (Directory.Exists(dir))
                    {
                        FileAttributes fileAttributes = File.GetAttributes(dir);
                        bool isSystem = (fileAttributes & FileAttributes.System) == FileAttributes.System;
                        bool isHidden = (fileAttributes & FileAttributes.Hidden) == FileAttributes.Hidden;
                        if (!isSystem && !isSystem)
                        {
                            CalcCluster(dir);
                        }
                    }
                } // for
            }

            catch (System.UnauthorizedAccessException e) {
                Basis.Error("Fehlerhafter Zugriff auf den Pfad\n" +
                    path + "\nFehler: " + e.ToString(),
                    "Fehler");
            }
            catch (Exception e) {
                Basis.Error("Fehlerhafter Zugriff auf den Pfad\n" +
                    path + "\nFehler: " + e.ToString(),
                    "Fehler");
            }
        } // calcCluster


    }

}
/*
 Windows Media-Formate (.asf, .wma, .wmv, .wm)
Windows Media-Metadateien (.asx, .wax, .wvx, .wpl)
Microsoft Digital Video Recording (.dvr-ms)
Windows Media Download-Paket (.wmd)
Audio Visual Interleave (.avi)
Moving Pictures Experts Group (.mpg, .mpeg, .m1v, .mp2, .mp3, .mpa, .mpe, .mpv2, .m3u)
Musical Instrument Digital Interface (.mid, .midi, .rmi)
Audio Interchange-Dateiformat ( .aif, .aifc, .aiff)
Sun Microsystems und NeXT (.au, .snd)
Audio für Windows (.wav)
CD-Audio-Track (.cda)
Indeo-Videotechnologie (.ivf)
Windows Media Player-Designs (.wmz, .wms)
QuickTime-Inhalte (.mov, .qt)
Dateiformate, die nicht unterstützt werden
Real Networks-Inhalte (.ra, .rm, .ram)
QuickTime-Inhalte (.mov, .qt)
MPEG-4 (.mp4)
Free Lossless Audio Codec (.flac)
*/