
import javax.swing.*; // JPanel Timer
import java.awt.*;
import java.awt.event.*;
import java.util.Stack;

public class ScheibenCanvas extends JPanel implements ActionListener {

	private Stack<Scheibe> stack = new Stack<Scheibe>();

	private Timer timer;
	private int timerintervall = 1000;

	private Kasten k1 = null;
	private Kasten k2 = null;
	private Kasten k3 = null;
	private int anz = 0;
	private int anzScheiben = 0;
	private Font font = new Font("Arial", Font.BOLD, 24);

	public boolean timerAbbruch = false;

	public ScheibenCanvas() {
	}

	public void startHanoi(int n, int timerintervall) {
		k1 = k2 = k3 = null;
		drawInit();
		this.timerintervall = timerintervall;
		this.anzScheiben = n;
		Graphics g = this.getGraphics();
		Scheibe e;
		int w = k1.getWidth();
		int diff = w / (n + 1);
		int h = k1.getHeight() / ((n) << 1);
		for (int i = n; i > 0; i--) {
			e = new Scheibe(w, h);
			System.out.println("w:" + w + "  h: " + h);
			k1.addEbene(e);
			w = w - diff;
		}
		paint(g);
		// time();
		anz = 0;
		//
	}

	public void drawInit() {
		int w = getWidth() / 16;
		int y = getHeight() - 80;
		System.out.println("w: " + w);
		if (w > 0 && y > 0) {
			if (k1 == null)
				k1 = new Kasten("A", w * 3, y, w << 2, getHeight() - 200, Color.RED, new Color(150, 0, 0));
			else
				k1.setBounds(w * 3, y, w << 2, getHeight() - 200);
			if (k2 == null)
				k2 = new Kasten("B", w * 3 + 5 * w, y, w << 2, getHeight() - 200, Color.GREEN, new Color(0, 150, 0));
			else
				k2.setBounds(w * 3 + 5 * w, y, w << 2, getHeight() - 200);
			if (k3 == null)
				k3 = new Kasten("C", w * 3 + 10 * w, y, w << 2, getHeight() - 200, Color.BLUE, new Color(0, 0, 150));
			else
				k3.setBounds(w * 3 + 10 * w, y, w << 2, getHeight() - 200);
		}
	} // setup

	public void nextStep() {
	}

	public void startTimer() {
		bewege(anzScheiben, k1, k2, k3);
	}

	// eintragen der Befehle in einen Stack
	// per Timer abarbeiten

	void bewege(int i, Kasten a, Kasten b, Kasten c) {
		if (i > 0) {
			Graphics g = this.getGraphics();
			bewege(i - 1, a, c, b);
			// verschiebe oberste Scheibe von a nach c;
			anz++;
			System.out.println(anz + ":  verschiebe oberste Ebene von " + a.getBez() + "  nach " + c.getBez());
			drawMove(a, c);
			paint(g);
			warten();
			bewege(i - 1, b, a, c);
		}
	}

	private void drawMove(Kasten a, Kasten b) {
		Graphics g = this.getGraphics();
		Scheibe ebene = a.removeEbene();
		paint(g);
		ebene.draw(g, a.getColor1(), a.getX(), 100);
		warten();

		paint(g); // draw
		ebene.draw(g, b.getColor1(), b.getX(), 100);
		warten();
		b.addEbene(ebene);
	}

	public void stopTimer() {
		if (timer != null) {
			timer.stop();
		}
	}

	public void stop() {
	}

	private void warten() {
		try {
			Thread.sleep(timerintervall);
		} catch (InterruptedException ex) {
			// Logger.getLogger(Pyramide_Grf.class.getName()).log(Level.SEVERE,
			// null, ex);
		}
	}

	@Override
	public void paint(Graphics g) {
		g.setColor(Color.WHITE);
		g.fillRect(0, 0, this.getWidth(), this.getHeight());
		g.setColor(Color.BLUE);
		g.setFont(font);
		String bez = "Die Trme von Hanoi";
		FontMetrics fontMetrics = g.getFontMetrics(g.getFont());
		int breite = fontMetrics.stringWidth(bez);
		g.drawString(bez, (getWidth() >> 1) - (breite >> 1), 40);
		g.drawString(anz + "", getWidth() >> 1, 100);
		drawInit(); // die grenzen werden immer berprft
		k1.draw(g);
		k2.draw(g);
		k3.draw(g);
	} // paint

	@Override
	public void actionPerformed(ActionEvent arg0) {

	}

}
