import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
//import java.util.logging.Level;
//import java.util.logging.Logger;

public class Hanoi extends JFrame implements ActionListener {

	private final String STARTTIMER = "Start Timer";  
	private final String STOPTIMER = "Stop Timer";  
	private final String STARTSTEP = "Start step";  
	private final String NEXTSTEP = "Next step";  
	private final String STOP = "Stop";
	
	JSpinner spNumberScheiben=null;
	JSpinner spNumberTimer=null;

	private final int MAX_WIDTH=1000;
	private final int MAX_HEIGHT=600;

	private final int TIMER_STEP=100;

  ScheibenCanvas  canvas = new ScheibenCanvas();  // Zeichenflaeche
 
  Font font = new Font("Arial", Font.BOLD, 24);

  public Hanoi() {
     setSize(MAX_WIDTH, MAX_HEIGHT);
     setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
     setGUI();
     canvas.drawInit();
     
     this.setVisible(true);
  }
  
  private void setGUI() {
	setLayout( new BorderLayout());
	JPanel panelBn = new JPanel(); // panel for the buttons 
	panelBn.setLayout( new FlowLayout());
	add(panelBn,BorderLayout.NORTH);
	
	panelBn.add(new JLabel("Anz Scheiben"));
	SpinnerNumberModel model1 = new SpinnerNumberModel(5, 1, 100, 1); // start, min, max, increment
	spNumberScheiben = new JSpinner(model1);
	panelBn.add(spNumberScheiben);
	
	JPanel pn = new JPanel();
	pn.setPreferredSize(new Dimension(30,10));
	panelBn.add(pn);		
	
	
	panelBn.add(new JLabel("Timer-step"));
	SpinnerNumberModel model2 = new SpinnerNumberModel(1000, 10, 10000, 100); // start, min, max, increment
	spNumberTimer = new JSpinner(model2);
	panelBn.add(spNumberTimer);
	
	pn = new JPanel();
	pn.setPreferredSize(new Dimension(30,10));
	panelBn.add(pn);	
	
	
	addButton(panelBn, STARTTIMER, STARTTIMER);
	addButton(panelBn, STOPTIMER, STOPTIMER);
	addButton(panelBn, STARTSTEP, STARTSTEP);
	addButton(panelBn, NEXTSTEP, NEXTSTEP);	
	addButton(panelBn, STOP, STOP);
	
	add(canvas, BorderLayout.CENTER);
    canvas.setBackground(Color.WHITE);
    

    setFonts(panelBn,16);
  }  // setGUI

  private void addButton(JPanel panelBn, String caption, String command){
		JButton bn = new JButton(caption);
		panelBn.add(bn);
		bn.setActionCommand(command);
		bn.addActionListener(this);		
	}  
  
  

	private void setFonts(Container cont, int size) {
		for (int i = 0; i < cont.getComponentCount(); i++) {
			Component c = cont.getComponent(i);
			if (c instanceof JPanel)
				setFonts((JPanel) c, size);
			else
				c.setFont(new Font("Arial", Font.BOLD, size));
		}  // for
	}  // setFonts

	  
      // wird von den Schaltern aufgerufen
  public void actionPerformed(ActionEvent e) {
	    if (e.getSource() instanceof JButton) {
			String cmd = e.getActionCommand();
			switch (cmd) {
			case STARTTIMER:startHanoi();
							canvas.startTimer();
				 			break;				 			
			case STOPTIMER: canvas.stopTimer();
							break;
			case STARTSTEP: startHanoi();
				 			break;
			case NEXTSTEP:  canvas.nextStep();
							break;
			case STOP:  canvas.stop();
							break;
			default: 		Basis.ErrorMsgBox("Wrong case in ActionListener", "Error");
			    			break;					
			} // switch
	    }
  }  // actionperformed


	private void startHanoi() {
		int anzScheiben = (int) spNumberScheiben.getValue();
		int time = (int) spNumberTimer.getValue();
		canvas.startHanoi( anzScheiben, time );
	}
   
    
  public static void main(String[] args) {
	  new Hanoi();    
 }

}  



