import java.util.ArrayList;
//import java.util.Random;
import java.util.concurrent.ThreadLocalRandom;

import java.util.Hashtable;
import java.util.HashMap;

import java.text.*; // NumberFormat 

// Hashtable is synchronized, whereas HashMap is not

import java.io.*;


public class HashTablePLZBeispiel {

   private final int min=1;
   private final int max=99999;
   
   private final int maxFeld=100000;

   private DecimalFormat df = new DecimalFormat("##0.00");
   
   
   int getPLZ() {
      int randomNum = ThreadLocalRandom.current().nextInt(min, max + 1);
      return randomNum;
   }


   public void test1() {
      int[] feld = new int[maxFeld];
      for (int i=0; i<maxFeld; i++) {
         feld[i] =getPLZ();         
      }
      long t1 =  System.currentTimeMillis();
      for (int i=0; i<maxFeld; i++) {
         int plz =getPLZ();         
         for (int j=0; j<maxFeld; j++) {
            if (plz == feld[i]) {
               break;
            }  // if
         } // for
      }  // for
      long t2 =  System.currentTimeMillis();
      
       System.out.println("test1: Lineare Suche"   + "Zeit: "+(t2-t1)+" ms" );  // 8400 ms
   }

   public void test2() {
      Object[][] feld = new Object[maxFeld][2];
      for (int i=0; i<maxFeld; i++) {
         feld[i][0] =getPLZ(); 
         feld[i][1] ="Stadt"+feld[i][0];
      }
      long t1 =  System.currentTimeMillis();
      for (int i=0; i<maxFeld; i++) {
         int plz =getPLZ();         
         for (int j=0; j<maxFeld; j++) {
            if (plz == (int)feld[i][0]) {
               break;
            }  // if
         } // for
      }  // for
      long t2 =  System.currentTimeMillis();
      System.out.println("test2: Lineare Suche PLZ-Array  Zeit: "+(t2-t1)+" ms" );  // 8400 ms
   }
   
   public void test3() {
      Object[] karteikarte=null;
      HashMap<Integer,Object[]> hashtable = new HashMap<Integer,Object[]>(150000, 0.70f);
      for (int i=0; i<maxFeld; i++) {
         karteikarte = new Object[2];
         int plz = getPLZ();
         karteikarte[0] =plz; 
         karteikarte[1] ="Stadt"+plz;
         hashtable.put(plz , karteikarte);
      }
      long t1 =  System.currentTimeMillis() ; // System.currentTimeMillis();
      for (int i=0; i<maxFeld; i++) {
         int plz =getPLZ();         
         karteikarte = (Object[]) hashtable.get( plz );
      }  // for
      long t2 =  System.currentTimeMillis() ; // System.currentTimeMillis();
      
      System.out.println("test3: Hashtable PLZ-Array  Zeit: "+(t2-t1)+" ms" );  // 8400 ms
      
   }

   public void test4() {
	      int n1=10;
	      int n2=10000;
      Object[] karteikarte=null;
      ArrayList<Object[]>[] array = new ArrayList[n1];
      for (int i=0; i<n1; i++) {
         array[i] = new ArrayList<Object[]>(100000);
      }
      
      for (int i=0; i<maxFeld; i++) {
         karteikarte = new Object[2];
         int plz = getPLZ();
         int key = plz/n2;
         karteikarte[0] =plz; 
         karteikarte[1] ="Stadt"+getPLZ();         
         array[key].add(karteikarte);
      }
      long t1 =  System.nanoTime() ; // System.currentTimeMillis();
      for (int i=0; i<maxFeld; i++) {
         int plz =getPLZ();         
         int key = plz/n2;
         //if (key>9) System.out.println("Test4: "+key);
         ArrayList<Object[]> liste = array[key];
         for (int j=0; j<liste.size(); j++) {
            Object[] obj =liste.get(j); 
            if (plz == (int)obj[0]) {
               break;
            }
         }
      }  // for
      long t2 =  System.nanoTime() ; // System.currentTimeMillis();      
      double time = (t2-t1)*1.0E-6;
      System.out.println("test4: n=10  HashArray lin. Suche Zeit: " +df.format(time)+" ms" );  // 8400 ms         
   }  // test4   

   public void test5() {
      int n1=1000;
      int n2=100;
      Object[] karteikarte=null;
      ArrayList<Object[]>[] array = new ArrayList[n1];
      for (int i=0; i<n1; i++) {
         array[i] = new ArrayList<Object[]>(100000);
      }      
      for (int i=0; i<maxFeld; i++) {
         karteikarte = new Object[2];
         int plz = getPLZ();
         int key = plz/n2;
         //if (key>0)System.out.println("Test5: "+plz+"   "+key);
         karteikarte[0] =plz; 
         karteikarte[1] ="Stadt"+getPLZ();
         
         array[key].add(karteikarte);
      }
      long t1 =  System.nanoTime() ; // System.currentTimeMillis();
      for (int i=0; i<maxFeld; i++) {
         int plz =getPLZ();         
         int key = plz/n2;
         ArrayList<Object[]> liste = array[key];
         for (int j=0; j<liste.size(); j++) {
            Object[] obj =liste.get(j); 
            if (plz == (int)obj[0]) {
               break;
            }
         }
      }  // for
      long t2 =  System.nanoTime() ; // System.currentTimeMillis();
      
      double time = (t2-t1)*1.0E-6;
      System.out.println("test5: n=1000 HashArray lin. Suche Zeit: " +df.format(time)+" ms" );  // 8400 ms         
   }  // test5
   
   
   
   
   private class Karteikarte {
      public int plz=0;
      public String stadt="";
      
      public Karteikarte(int plz, String stadt) {
         this.plz=plz;
         this.stadt=stadt;
      }      
   }
   
   public void test6() {
      Karteikarte karteikarte=null;
      HashMap<Integer,Karteikarte> hashtable = new HashMap<Integer,Karteikarte>(150000, 0.70f);
      for (int i=0; i<maxFeld; i++) {
         int plz = getPLZ();
         karteikarte = new Karteikarte(plz, "Stadt"+plz); 
         hashtable.put(plz , karteikarte);
      }
      long t1 =  System.nanoTime() ; // System.currentTimeMillis();
      for (int i=0; i<maxFeld; i++) {
         int plz =getPLZ();         
         karteikarte = (Karteikarte) hashtable.get( plz );
      }  // for
      long t2 =  System.nanoTime() ; // System.currentTimeMillis();
      
      double time = (t2-t1)*1.0E-6;
      System.out.println("test6:  HashTable mit Object    Zeit: "+df.format(time)+" ms" );  // 8400 ms         
      
   }   
   
   private void test7() {
      int n1=10;
      int n2=10000;
      Karteikarte karteikarte=null;
      ArrayList<Karteikarte>[] array = new ArrayList[n1];
      for (int i=0; i<n1; i++) {
         array[i] = new ArrayList<Karteikarte>(100000);
      }
      
      for (int i=0; i<maxFeld; i++) {
         int plz = getPLZ();
         int key = plz/n2;
         karteikarte = new Karteikarte(plz,"Stadt"+getPLZ() );         
         array[key].add(karteikarte);
      }
      long t1 =  System.nanoTime() ; // System.currentTimeMillis();
      for (int i=0; i<maxFeld; i++) {
         int plz =getPLZ();         
         int key = plz/n2;
         ArrayList<Karteikarte> liste = array[key];
         for (int j=0; j<liste.size(); j++) {
            karteikarte =liste.get(j); 
            if (plz == karteikarte.plz) {
               break;
            }
         }
      }  // for
      long t2 =  System.nanoTime() ; // System.currentTimeMillis();
      
      double time = (t2-t1)*1.0E-6;
      System.out.println("Test7  n=10 Object-Arrays   Zeit: "+df.format(time)+" ms" );  // 8400 ms               
   }
   
   
   private void test8() {
      int n1=1000;
      int n2=100;
      Karteikarte karteikarte=null;
      ArrayList<Karteikarte>[] array = new ArrayList[n1];
      for (int i=0; i<n1; i++) {
         array[i] = new ArrayList<Karteikarte>(10000);
      }
      
      for (int i=0; i<maxFeld; i++) {
         int plz = getPLZ();
         int key = plz/n2;
         karteikarte = new Karteikarte(plz,"Stadt"+getPLZ() );         
         array[key].add(karteikarte);
      }
      long t1 =  System.nanoTime() ; // System.currentTimeMillis();
      for (int i=0; i<maxFeld; i++) {
         int plz =getPLZ();         
         int key = plz/n2;
         ArrayList<Karteikarte> liste = array[key];
         for (int j=0; j<liste.size(); j++) {
            karteikarte =liste.get(j); 
            if (plz == karteikarte.plz) {
               break;
            }
         }
      }  // for
      long t2 =  System.nanoTime() ; // System.currentTimeMillis();
      
      double time = (t2-t1)*1.0E-6;
      System.out.println("Test8  n=1000 Object-Arrays   Zeit: "+df.format(time)+" ms" );  // 8400 ms               
   }   
   
   public static void main(String[] args) {
      HashTablePLZBeispiel instanz = new HashTablePLZBeispiel();
   //   instanz.test1();
    //  instanz.test2();
instanz.test3();
  instanz.test4();
      instanz.test5();
    /*  
    
      instanz.test6();
      instanz.test7();
      instanz.test8();*/
      pause();
  pause();
   }

 private static void pause() {
    try {
      System.in.read();
    }
    catch (IOException e) {
    }
  }  // pause


}
