﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation; 
using System.Windows.Shapes;

using System.IO;
using Microsoft.Win32;
using System.ComponentModel;

namespace Seek {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {


/*

Number: 131072
Datum: 20191019
datas[0] = 131072000
datas[1] = 131072001
datas[2] = 131072002
datas[3] = 131072003
datas[4] = 131072004
datas[5] = 131072005
datas[6] = 131072006
datas[7] = 131072007
datas[8] = 131072008
datas[9] = 131072009

*/

        private const int C_VERSION = 2;

        private Int32 MAXSTRUCTS = 131072;
        private Int32 MAXARRAY = 4094;

        private BackgroundWorker worker = null;
        private DateTime Time1, Time2;

        private String filename = "";
        private SeekData lastdata;


        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            bnWriteData.IsEnabled = false;
            bnReadDataComplete.IsEnabled = false;
            bnReadDataSeek.IsEnabled = false;

            setEnabled(true);



            if (File.Exists("d:\\progs\\wpf\\Beispiele\\Seek\\Seek.sln")) {
                tFilename.Text = "d:\\seek\\test.bin";
            }
            else {
                tFilename.Text = "c:\\seek\\test.bin";
            }
        }

        private void setEnabled(bool value) {
            bnWriteData.IsEnabled = value;
            bnReadDataComplete.IsEnabled = value;
            bnReadDataSeek.IsEnabled = value;
        }

        private void bnOpenFile_click(Object sender, RoutedEventArgs e) {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "Testdatei (*.bin)|*.bin|Alle Dateien (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".bin";
            openFileDialog1.InitialDirectory = "";
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == true) {
                tFilename.Text = openFileDialog1.FileName;
                setEnabled(true);
            }
        }

       

        private void bnWriteData_Click(Object sender, RoutedEventArgs e) {
            filename = tFilename.Text.Trim();

            String path, filenameShort;
            Basis.splitFilename(filename, out path, out filenameShort);
            if (!Directory.Exists(path)) {
                if (!Basis.createPath(path)) {
                    Basis.ErrorMsg("Das Verzeichnis konnte nicht erstellt werden", "Fehler");
                    return;
                }
            }


            progressbar.Maximum = MAXSTRUCTS;
            progressbar.Value = 0;
            indexProgressbar = 0;
            abbruch = false;
            Time1 = DateTime.Now;

            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.DoWork += WriteDataAction;
            worker.ProgressChanged += worker_ProgressChangedWrite;
            worker.RunWorkerAsync();
        }



        bool abbruch = false;
        int indexProgressbar = 0;
        void worker_ProgressChangedWrite(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum || abbruch) {
                progressbar.Value = 0;
                Time2 = DateTime.Now;
                TimeSpan duration1 = Time2 - Time1;
                StringBuilder sb = new StringBuilder();
                sb.AppendLine("Habe fertig\r\nDauer: " +duration1);
                sb.AppendLine();
                sb.AppendLine();

                sb.AppendLine("lastdata");
                sb.AppendLine("Number: " + lastdata.number);
                sb.AppendLine("Datum: " + lastdata.datum);
                for (int j = 0; j < 10; j++) {
                    sb.AppendLine("datas[" + j + "] = " + lastdata.datas[j]);
                }

                editor.Text = sb.ToString();
            }
            else {
                // labelProgressbar.Content = "Installieren des " + version + ".Updates";
            }
        }


        private void WriteDataAction(object sender, DoWorkEventArgs e) {
            try {
                FileStream oFile = new FileStream(filename, FileMode.Create);
                BinaryWriter binStream = new BinaryWriter(oFile);
                binStream.Write(C_VERSION);  // Versionkontrolle !!!
                binStream.Write(MAXSTRUCTS);  // Int32
                binStream.Write(MAXARRAY);   // Int32

                for (int i = 0; i < MAXSTRUCTS; i++) {
                    SeekData sdata = new SeekData();
                    sdata.datas = new long[MAXARRAY];
                    sdata.number = i + 1;
                    sdata.datum = 20191019;
                    for (int j = 0; j < MAXARRAY; j++) {
                        sdata.datas[j] = sdata.number * 1000 + j;
                    }
                    sdata.write2File(binStream);
                    worker.ReportProgress(++indexProgressbar);
                    if (i == (MAXSTRUCTS - 1)) {
                        lastdata = sdata;
                    }
                }

                binStream.Close();
                oFile.Close();
            }                        
            catch (Exception e2) {
                // OOOOH, an Error
                Basis.ErrorMsg(e2.ToString(), "WriteDataAction");
            }            
        }


        // READ READ READ

        private void bnReadDataComplete_Click(Object sender, RoutedEventArgs e) {
            filename = tFilename.Text.Trim();

            String path, filenameShort;
            Basis.splitFilename(filename, out path, out filenameShort);
            if (!Directory.Exists(path)) {
                if (!Basis.createPath(path)) {
                    Basis.ErrorMsg("Das Verzeichnis konnte nicht erstellt werden", "Fehler");
                    return;
                }
            }


            progressbar.Maximum = MAXSTRUCTS;
            progressbar.Value = 0;
            indexProgressbar = 0;
            abbruch = false;
            Time1 = DateTime.Now;

            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.DoWork += ReadDataActionComplete;
            worker.ProgressChanged += worker_ProgressChangedReadComplete;
            worker.RunWorkerAsync();            
        }

        void worker_ProgressChangedReadComplete(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum || abbruch) {
                progressbar.Value = 0;
                Time2 = DateTime.Now;
                TimeSpan duration1 = Time2 - Time1;
                StringBuilder sb = new StringBuilder();
                sb.AppendLine("Read Complete\r\nDauer: " + duration1);
                sb.AppendLine();
                sb.AppendLine();

                sb.AppendLine("lastdata");
                sb.AppendLine("Number: " + lastdata.number);
                sb.AppendLine("Datum: " + lastdata.datum);
                for (int j = 0; j < 10; j++) {
                    sb.AppendLine("datas[" + j + "] = " + lastdata.datas[j]);
                }

                editor.AppendText(sb.ToString());
            }
            else {
                // labelProgressbar.Content = "Installieren des " + version + ".Updates";
            }
        }


        private void ReadDataActionComplete(object sender, DoWorkEventArgs e) {
            try {
                FileStream inFile = new FileStream(filename, FileMode.Open);
                BinaryReader binStream = new BinaryReader(inFile);

                int version = binStream.ReadInt32();
                int anzStructs = binStream.ReadInt32(); // MAXSTRUCTS
                int maxarray = binStream.ReadInt32(); // MAXSTRUCTS

                SeekData sdata = new SeekData();
                sdata.datas = new long[maxarray];
                for (int i = 0; i < anzStructs; i++) {
                    // SeekData sdata = new SeekData();
                    
                    sdata.readFromFile(binStream);
                    worker.ReportProgress(++indexProgressbar);
                    if (i == (anzStructs - 1)) {
                        lastdata = sdata;
                    }
                }
                binStream.Close();
                inFile.Close();
            }
            catch (Exception e2) {
                // OOOOH, an Error
                Basis.ErrorMsg(e2.ToString(), "ReadDataActionComplete");
            }
        }

        // ------------------------------------

        
        private void bnReadBytesComplete_Click(Object sender, RoutedEventArgs e) {
            filename = tFilename.Text.Trim();

            String path, filenameShort;
            Basis.splitFilename(filename, out path, out filenameShort);
            if (!Directory.Exists(path)) {
                if (!Basis.createPath(path)) {
                    Basis.ErrorMsg("Das Verzeichnis konnte nicht erstellt werden", "Fehler");
                    return;
                }
            }


            progressbar.Maximum = MAXSTRUCTS;
            progressbar.Value = 0;
            indexProgressbar = 0;
            abbruch = false;
            Time1 = DateTime.Now;

            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.DoWork += ReadBytesActionComplete;
            worker.ProgressChanged += worker_ProgressChangedReadBytesComplete;
            worker.RunWorkerAsync();
        }

        void worker_ProgressChangedReadBytesComplete(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum || abbruch) {
                progressbar.Value = 0;
                Time2 = DateTime.Now;
                TimeSpan duration1 = Time2 - Time1;
                StringBuilder sb = new StringBuilder();
                sb.AppendLine("Read Complete\r\nDauer: " + duration1);
                sb.AppendLine();
                sb.AppendLine();

                sb.AppendLine("lastdata");
                sb.AppendLine("Number: " + lastdata.number);
                sb.AppendLine("Datum: " + lastdata.datum);
                for (int j = 0; j < 10; j++) {
                    sb.AppendLine("datas[" + j + "] = " + lastdata.datas[j]);
                }

                editor.AppendText(sb.ToString());
            }
            else {
                // labelProgressbar.Content = "Installieren des " + version + ".Updates";
            }
        }


        private void ReadBytesActionComplete(object sender, DoWorkEventArgs e) {
            try {
                FileStream inFile = new FileStream(filename, FileMode.Open);
                BinaryReader binStream = new BinaryReader(inFile);

                int version = binStream.ReadInt32();
                int anzStructs = binStream.ReadInt32(); // MAXSTRUCTS
                int maxarray = binStream.ReadInt32(); // MAXSTRUCTS

                int sizeStruct = (maxarray + 2) << 3;                
                byte[] buffer = new byte[sizeStruct];
                for (int i = 0; i < anzStructs-1; i++) {
                    binStream.Read(buffer, 0, sizeStruct);
                    worker.ReportProgress(++indexProgressbar);
                }
                SeekData sdata = new SeekData();  
                sdata.datas = new long[maxarray];
                sdata.readFromFile(binStream);
                worker.ReportProgress(++indexProgressbar);
                lastdata = sdata;
                binStream.Close();
                inFile.Close();
            }
            catch (Exception e2) {
                // OOOOH, an Error
                Basis.ErrorMsg(e2.ToString(), "ReadDataActionComplete");
            }
        }

        // ------------------------------------


        private void bnReadDataSectornumber_click(Object sender, RoutedEventArgs e) {
            long seekNumber;
            if (long.TryParse(tRecordNumber.Text.Trim(), out seekNumber)) {
                if (seekNumber<1) {
                    Basis.ErrorMsg("Die Seeknummer muss größer Null sein", "Fehler");
                }
                else {
                    ReadDataSeekSectornumber(seekNumber);
                }
            }
            else {
                Basis.ErrorMsg("Die Seeknummer ist nicht numerisch", "Fehler");
            }
        }

        private void bnReadDataSeek_Click(Object sender, RoutedEventArgs e) {
            ReadDataSeekSectornumber(MAXSTRUCTS);
        }

        private void ReadDataSeekSectornumber(long seekNumber) {
            filename = tFilename.Text.Trim();

            String path, filenameShort;
            Basis.splitFilename(filename, out path, out filenameShort);
            if (!Directory.Exists(path)) {
                if (!Basis.createPath(path)) {
                    Basis.ErrorMsg("Das Verzeichnis konnte nicht erstellt werden", "Fehler");
                    return;
                }
            }

            try {
                FileStream inFile = new FileStream(filename, FileMode.Open);
                BinaryReader binStream = new BinaryReader(inFile);

                int version = binStream.ReadInt32();
                int anzStructs = binStream.ReadInt32(); // MAXSTRUCTS
                int maxarray = binStream.ReadInt32(); // MAXSTRUCTS

                if (seekNumber> anzStructs) {
                    binStream.Close();
                    inFile.Close();
                    Basis.ErrorMsg("Die SeekNummer ist zu groß\r\nSeekNumber: "+ seekNumber+"\r\nMaxNumber: "+anzStructs, "Fehler");
                    return;
                }

                long position = seekNumber - 1;
                long seeksizeSeekData = (2 + maxarray) << 3;    // SeekData:  (number/Datum + array)*8
                long seekposition = position * seeksizeSeekData + 3*4;

                inFile.Seek(seekposition, SeekOrigin.Begin);

                SeekData sdata = new SeekData();
                sdata.datas = new long[MAXARRAY];
                sdata.readFromFile(binStream);
                lastdata = sdata;

                binStream.Close();
                inFile.Close();

                StringBuilder sb = new StringBuilder();
                sb.AppendLine("lastdata");
                sb.AppendLine("Number: " + lastdata.number);
                sb.AppendLine("Datum: " + lastdata.datum);
                for (int j = 0; j < 10; j++) {
                    sb.AppendLine("datas[" + j + "] = " + lastdata.datas[j]);
                }
                editor.Text = sb.ToString();
            }
            catch (Exception e2) {
                // OOOOH, an Error
                Basis.ErrorMsg(e2.ToString(), "ReadDataActionSeek");
            }
        }  // bnReadDataSeek_Click

    }
}
